% indx : ط§غŒظ†ع©ظ‡ ع†ظ†ط¯ط¬ظ…ظ„ظ‡ ط§غŒ ط¯ط±ظˆظ†غŒط§ط¨ ط§ط² ع©ط¯ط§ظ… ظ†ظ‚ط§ط· ع¯ط±ظ‡غŒ ط¨ط±ط§غŒ طھظˆظ„غŒط¯ ط´ط¯ظ† ط§ط³طھظ?ط§ط¯ظ‡ ع©ظ†ط¯
% warning: indexes are NOT zero based!

function Tafazole_pishro(start_indx,stop_indx,h,resolution,new_fig)
    global func0_x func0_y;
    func0_x = [-2,-1.75,-1.5,-1.25,-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1,1.25,1.5,1.75,2];
    func0_y = [0.0099 ,16/1241 ,4/229,16/641  ,0.038     ,16/241  ,4/29 ,16/41  ,1      ,16/41,4/29,16/241,0.038,16/641,4/229,16/1241,0.0099] ;
    
    func01_x = func0_x(start_indx:stop_indx);
    func01_y = func0_y(start_indx:stop_indx);
	
	point_count = stop_indx - start_indx +1;
	step_x = 1/resolution;
	%----------------------
	x_min = min(func01_x);
	x_max = max(func01_x);
	%----------------------
	y_min = min(func01_y);
	y_max = max(func01_y);
	%----------------------
	points_x = x_min:step_x:x_max;
	%======================================
	points_y = zeros(1,resolution*(abs(x_max-x_min))+1);
	
	
	
	for array_indx=1:resolution*(abs(x_max-x_min))+1 
		for	indx = 1 : point_count-1
			points_y(array_indx) = points_y(array_indx) + tafaazole_pishro_P( points_x(array_indx)  ,func0_x(start_indx),h,indx)              *           tafaazole_pishro(indx,start_indx-1);
		end
		points_y(array_indx) = points_y(array_indx) + func0_y(start_indx);
	end
	%======================================
	if(new_fig==1)
		figure;
	end
	set(gcf,'color','white');
	if(new_fig==1)
		plot(points_x,points_y,'b','MarkerSize',10);
	else
		plot(points_x,points_y,'g','MarkerSize',15);
	end
	
	hold on;
	plot(func01_x,func01_y,'r.','MarkerSize',25);
end

function val = tafaazole_pishro(martabe , andis) % j IS zero based
	global func0_x func0_y;
	if(martabe~=1)
		val = tafaazole_pishro(martabe-1,andis+1) - tafaazole_pishro(martabe-1,andis);
	else
		val = func0_y(andis+2) - func0_y(andis+1);
	end
end

function p = tafaazole_pishro_P(x , x_i,h,j)
	global func0_x func0_y;
	%-------------------------
	u=(x-x_i)/h;
	tmp=1;
	for jj=1:j
		tmp = tmp * (u-j+jj);
	end
	tmp = tmp / factorial(j);
	%--------------------------
	p = tmp;
end